unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Wave, jpeg, ExtCtrls, Buttons, StdCtrls, CoolForm;
const
  ntips = 8;
  nqws  = 11;
type
  qwst = record
           qws  : pchar{string};
           ptip : char;
           yn   : integer;
           ok   : boolean;
         end;
  qrec = array[1..ntips,1..nqws] of qwst;
 { rzlt = array[1..ntips] of integer;}
  qrnd = array[1..ntips,1..nqws] of boolean;
  TForm1 = class(TForm)
    Wave1: TWave;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    Wave2: TWave;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    SpeedButton6: TSpeedButton;
    Memo1: TMemo;
    CoolForm1: TCoolForm;
    SpeedButton7: TSpeedButton;
    SaveDialog1: TSaveDialog;
    OpenDialog1: TOpenDialog;
    procedure FormActivate(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
    procedure SpeedButton6Click(Sender: TObject);
    procedure HideMenu;
    procedure ShowMenu;
    procedure Test(Var _q : qwst);
    procedure ResGenerate(Y_N : Boolean);
    procedure Initialize;
    procedure Veryfic;
    procedure YesNo;
    procedure SpeedButton7Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1                              : TForm1;
  CCls                               : Boolean;
  qarr                               : qrec;
  qrn                                : qrnd;
  q                                  : qwst;
  {  }
  A,B                                : integer;
  E,I,S,N,T,F,J,P                    : char;
  RezTip                             : string[4];
{  RezInt                             : rzlt;}
  Sender                             : TObject;
  NN                                 : integer;
  mems                               : boolean;
  DIR                                : string;
  F1                                 : File of String[4];

implementation

{$R *.DFM}
procedure TForm1.YesNo;
Begin
  SpeedButton5.Visible  := False;
  SpeedButton6.Visible  := False;
End;
procedure TForm1.HideMenu;
Begin
  {   }
  SpeedButton1.Visible  := False;
  SpeedButton2.Visible  := False;
  SpeedButton3.Visible  := False;
  SpeedButton4.Visible  := False;
  SpeedButton7.Visible  := False;

End;
procedure TForm1.ShowMenu;
Begin
  {   }
  SpeedButton1.Visible  := True;
  SpeedButton2.Visible  := True;
  SpeedButton3.Visible  := True;
  SpeedButton4.Visible  := True;
  SpeedButton7.Visible  := True;  
  SpeedButton5.Visible  := False;
  SpeedButton6.Visible  := False;

End;

procedure TForm1.Test(Var _q : qwst);
{Var
  ents    : string;}
Begin
  {  }
  Memo1.Clear;
{  Memo1.Lines.Add(IntToStr(NN) + '    ' +  _q.ptip);}
  Memo1.Lines.Add(_q.qws);

End;

procedure TForm1.Initialize;
Begin
  E := 'E'; I := 'I'; S := 'S'; N := 'N'; T := 'T'; F := 'F'; J := 'J'; P := 'P';
  A := 1; B := 1; NN := 1; mems := False;
  {  }
  qarr[1,1].qws   := '-   ,   .    ,       ,   ,   .';
  qarr[1,1].pTip  := E;
  qarr[1,1].ok    := True;
  qarr[1,2].qws   := '-           " ";        ,    ,  ';
  qarr[1,2].pTip  := E;
  qarr[1,2].ok    := True;
  qarr[1,3].qws   := '-           .    ,    " ".';
  qarr[1,3].pTip  := E;
  qarr[1,3].ok    := True;
  qarr[1,4].qws   := '-           , ,  ,         .';
  qarr[1,4].pTip  := E;
  qarr[1,4].ok    := True;
  qarr[1,5].qws   := '-    ,     .';
  qarr[1,5].pTip  := E;
  qarr[1,5].ok    := True;
  qarr[1,6].qws   := '-                 .       .';
  qarr[1,6].pTip  := E;
  qarr[1,6].ok    := True;
  qarr[1,7].qws   := '-      ,    .         .   () .';
  qarr[1,7].pTip  := E;
  qarr[1,7].ok    := True;
  qarr[1,8].qws   := '-    ,   .                   .';
  qarr[1,8].pTip  := E;
  qarr[1,8].ok    := True;
  qarr[1,9].qws   := '-  ""   ,  ...        ,     : ",     ?..."';
  qarr[1,9].pTip  := E;
  qarr[1,9].ok    := True;
  qarr[1,10].qws  := '-         ,  ,   ,  ,   ,     .';
  qarr[1,10].pTip := E;
  qarr[1,10].ok   := True;
  qarr[1,11].ok   := False;
  {  }
  qarr[2,1].qws   := '-   ,   ,   ,    .   :"   "  "     ".';
  qarr[2,1].pTip  := I;
  qarr[2,1].ok    := True;
  qarr[2,2].qws   := '-    ,  ,       ,     ,       ,    ..';
  qarr[2,2].pTip  := I;
  qarr[2,2].ok    := True;
  qarr[2,3].qws   := '-  " ",  ,    .';
  qarr[2,3].pTip  := I;
  qarr[2,3].ok    := True;
  qarr[2,4].qws   := '-    ;   ,       ,     .';
  qarr[2,4].pTip  := I;
  qarr[2,4].ok    := True;
  qarr[2,5].qws   := '-          .';
  qarr[2,5].pTip  := I;
  qarr[2,5].ok    := True;
  qarr[2,6].qws   := '-       ;    ,  -   ,      .';
  qarr[2,6].pTip  := I;
  qarr[2,6].ok    := True;
  qarr[2,7].qws   := '-  ,           ;      , ,      .';
  qarr[2,7].pTip  := I;
  qarr[2,7].ok    := True;
  qarr[2,8].qws   := '-       ,      .';
  qarr[2,8].pTip  := I;
  qarr[2,8].ok    := True;
  qarr[2,9].qws   := '-       :"      ";  , , ,        .';
  qarr[2,9].pTip  := I;
  qarr[2,9].ok    := True;
  qarr[2,10].qws  := '- ,  "  ";   ,    ,  ,  -  ,   .';
  qarr[2,10].pTip := I;
  qarr[2,10].ok   := True;
  qarr[2,11].ok   := False;
  {  }
  qarr[3,1].qws   := '-        ;   ,   ,   : "  ",   "  ".';
  qarr[3,1].pTip  := S;
  qarr[3,1].ok    := True;
  qarr[3,2].qws   := '-            ,   ;  ,     -,    .';
  qarr[3,2].pTip  := S;
  qarr[3,2].ok    := True;
  qarr[3,3].qws   := '-     ,    ;         ,    ,     .';
  qarr[3,3].pTip  := S;
  qarr[3,3].ok    := True;
  qarr[3,4].qws   := '- , , "   ,   ";    ,     .';
  qarr[3,4].pTip  := S;
  qarr[3,4].ok    := True;
  qarr[3,5].qws   := '-       ,     ;  ,            ,    .';
  qarr[3,5].pTip  := S;
  qarr[3,5].ok    := True;
  qarr[3,6].qws   := '-    ;   ,      ,    " ".';
  qarr[3,6].pTip  := S;
  qarr[3,6].ok    := True;
  qarr[3,7].qws   := '-  ,    ;    ,     .';
  qarr[3,7].pTip  := S;
  qarr[3,7].ok    := True;
  qarr[3,8].qws   := '- ,      ,    ,  ,      ,       .';
  qarr[3,8].pTip  := S;
  qarr[3,8].ok    := True;
  qarr[3,9].qws   := '-     ;   ,     ,     : "  ?".';
  qarr[3,9].pTip  := S;
  qarr[3,9].ok    := True;
  qarr[3,10].qws  := '-      ,    ;       ,    ,       .';
  qarr[3,10].pTip := S;
  qarr[3,10].ok   := True;
{  qarr[3,11].qws  := '-   ,  "   ,    ";   : "  ",      ,    .';
  qarr[3,11].pTip := S;}
  qarr[3,11].ok   := False;
  {  }
  qarr[4,1].qws   := '-      ;        .';
  qarr[4,1].pTip  := N;
  qarr[4,1].ok    := True;
  qarr[4,2].qws   := '-         ,  ;     ,      ,    .';
  qarr[4,2].pTip  := N;
  qarr[4,2].ok    := True;
  qarr[4,3].qws   := '-  "  ".';
  qarr[4,3].pTip  := N;
  qarr[4,3].ok    := True;
  qarr[4,4].qws   := '- ,    ;   ,  ,      ,       .';
  qarr[4,4].pTip  := N;
  qarr[4,4].ok    := True;
  qarr[4,5].qws   := '-          .';
  qarr[4,5].pTip  := N;
  qarr[4,5].ok    := True;
  qarr[4,6].qws   := '-       ,      .';
  qarr[4,6].pTip  := N;
  qarr[4,6].ok    := True;
  qarr[4,7].qws   := '-      ,    ,  ;    : "   ?".';
  qarr[4,7].pTip  := N;
  qarr[4,7].ok    := True;
  qarr[4,8].qws   := '-       ;  ,      ,   ,      .';
  qarr[4,8].pTip  := N;
  qarr[4,8].ok    := True;
  qarr[4,9].qws   := '-  ,     ,  ,     .';
  qarr[4,9].pTip  := N;
  qarr[4,9].ok    := True;
  qarr[4,10].ok   := False;
  qarr[4,11].ok   := False;
  {  }
  qarr[5,1].qws   := '-    ,    .';
  qarr[5,1].pTip  := T;
  qarr[5,1].ok    := True;
  qarr[5,2].qws   := '-     ,         ,     .';
  qarr[5,2].pTip  := T;
  qarr[5,2].ok    := True;
  qarr[5,3].qws   := '-      ;           ,     .';
  qarr[5,3].pTip  := T;
  qarr[5,3].ok    := True;
  qarr[5,4].qws   := '-      ",   ",  " ";    - ,      ,  ,       .';
  qarr[5,4].pTip  := T;
  qarr[5,4].ok    := True;
  qarr[5,5].qws   := '-      ,          (     ).';
  qarr[5,5].pTip  := T;
  qarr[5,5].ok    := True;
  qarr[5,6].qws   := '-       ,      ,        .';
  qarr[5,6].pTip  := T;
  qarr[5,6].ok    := True;
  qarr[5,7].qws   := '- ,    ,  ;    ,          .';
  qarr[5,7].pTip  := T;
  qarr[5,7].ok    := True;
  qarr[5,8].qws   := '-   ,     .';
  qarr[5,8].pTip  := T;
  qarr[5,8].ok    := True;
  qarr[5,9].qws   := '-     ,    .';
  qarr[5,9].pTip  := T;
  qarr[5,9].ok    := True;
  qarr[5,10].ok   := False;
  qarr[5,11].ok   := False;
  {  }
  qarr[6,1].qws   := '-        ,      .';
  qarr[6,1].pTip  := F;
  qarr[6,1].ok    := True;
  qarr[6,2].qws   := '- ,   ""  ;     ,  -   .';
  qarr[6,2].pTip  := F;
  qarr[6,2].ok    := True;
  qarr[6,3].qws   := '-     ,  - - ;   ,        ,        .';
  qarr[6,3].pTip  := F;
  qarr[6,3].ok    := True;
  qarr[6,4].qws   := '-      ;      ,  : "     ,       ?".';
  qarr[6,4].pTip  := F;
  qarr[6,4].ok    := True;
  qarr[6,5].qws   := '-     ,   ,  -    .';
  qarr[6,5].pTip  := F;
  qarr[6,5].ok    := True;
  qarr[6,6].qws   := '-  : "   -,   ?" -       .';
  qarr[6,6].pTip  := F;
  qarr[6,6].ok    := True;
  qarr[6,7].qws   := '-  ,     ,   - ;       .';
  qarr[6,7].pTip  := F;
  qarr[6,7].ok    := True;
  qarr[6,8].qws   := '-   ;      ,       ,     ("  "),     ("     ").';
  qarr[6,8].pTip  := F;
  qarr[6,8].ok    := True;
  qarr[6,9].qws   := '-     ,      .';
  qarr[6,9].pTip  := F;
  qarr[6,9].ok    := True;
  qarr[6,10].ok   := False;
  qarr[6,11].ok   := False;
  {  }
  qarr[7,1].qws   := '-   ,    .';
  qarr[7,1].pTip  := J;
  qarr[7,1].ok    := True;
  qarr[7,2].qws   := '-          ,    .';
  qarr[7,2].pTip  := J;
  qarr[7,2].ok    := True;
  qarr[7,3].qws   := '- "", ,      ,    (   ,    ),        .';
  qarr[7,3].pTip  := J;
  qarr[7,3].ok    := True;
  qarr[7,4].qws   := '-  , ,   ;   ,   ,    ,  -    .';
  qarr[7,4].pTip  := J;
  qarr[7,4].ok    := True;
  qarr[7,5].qws   := '-         .';
  qarr[7,5].pTip  := J;
  qarr[7,5].ok    := True;
  qarr[7,6].qws   := '-        ;     -,    ,         ,     .';
  qarr[7,6].pTip  := J;
  qarr[7,6].ok    := True;
  qarr[7,7].qws   := '-   ;                     .';
  qarr[7,7].pTip  := J;
  qarr[7,7].ok    := True;
  qarr[7,8].qws   := '-   ,    ,     .';
  qarr[7,8].pTip  := J;
  qarr[7,8].ok    := True;
  qarr[7,9].qws   := '-       , ,   ,       -  ,      .';
  qarr[7,9].pTip  := J;
  qarr[7,9].ok    := True;
  qarr[7,10].ok   := False;
  qarr[7,11].ok   := False;

  {  }
  qarr[8,1].qws   := '-     ;   "   ".';
  qarr[8,1].pTip  := P;
  qarr[8,1].ok    := True;
  qarr[8,2].qws   := '-     -           .';
  qarr[8,2].pTip  := P;
  qarr[8,2].ok    := True;
  qarr[8,3].qws   := '-     ,      ;     ,        .';
  qarr[8,3].pTip  := P;
  qarr[8,3].ok    := True;
  qarr[8,4].qws   := '-    ,     ,       ;      ,        ,     .';
  qarr[8,4].pTip  := P;
  qarr[8,4].ok    := True;
  qarr[8,5].qws   := '-    ,      -       ;    ,      ,       .';
  qarr[8,5].pTip  := P;
  qarr[8,5].ok    := True;
  qarr[8,6].qws   := '-     ;     , ,  , ,        .';
  qarr[8,6].pTip  := P;
  qarr[8,6].ok    := True;
  qarr[8,7].qws   := '-        ;        ,    ,  ,   .';
  qarr[8,7].pTip  := P;
  qarr[8,7].ok    := True;
  qarr[8,8].qws   := '-       .';
  qarr[8,8].pTip  := P;
  qarr[8,8].ok    := True;
  qarr[8,9].qws   := '-       ; ,       -    .';
  qarr[8,9].pTip  := P;
  qarr[8,9].ok    := True;
  qarr[8,10].ok   := False;
  qarr[8,11].ok   := False;



End;

procedure TForm1.FormActivate(Sender: TObject);
begin
  GetDir(0,DIR);
  SpeedButton1.Visible  := False;
  Form1.Width  := CoolForm1.Picture.Width;
  Form1.Height := CoolForm1.Picture.Height;
{  Form1.AutoSize        := True;}
  CCls := True;
  Wave1.Play;
  {}
  SpeedButton1.Width  := SpeedButton1.Glyph.Width-4;
  SpeedButton1.Height := SpeedButton1.Glyph.Height-5;
  SpeedButton1.Left := CoolForm1.Width -50;
  SpeedButton1.Top  := CoolForm1.Top + 80;
  SpeedButton1.Visible  := True;
  {}
  SpeedButton2.Width  := SpeedButton2.Glyph.Width-4;
  SpeedButton2.Height := SpeedButton2.Glyph.Height-5;
  SpeedButton2.Left := CoolForm1.Left + trunc((CoolForm1.Width - SpeedButton2.Width)/2)+5;
  SpeedButton2.Top  := CoolForm1.Top + 445;
  SpeedButton2.Visible  := True;
  {}
  SpeedButton3.Width  := SpeedButton3.Glyph.Width-4;
  SpeedButton3.Height := SpeedButton3.Glyph.Height-5;
  SpeedButton3.Left := CoolForm1.Left + trunc((CoolForm1.Width - SpeedButton3.Width)/2)+5;
  SpeedButton3.Top  := CoolForm1.Top + 475;
  SpeedButton3.Visible  := True;
  {}
  SpeedButton4.Width  := SpeedButton4.Glyph.Width-4;
  SpeedButton4.Height := SpeedButton4.Glyph.Height-5;
  SpeedButton4.Left := CoolForm1.Left + trunc((CoolForm1.Width - SpeedButton4.Width)/2)+5;
  SpeedButton4.Top  := CoolForm1.Top + 535;
  SpeedButton4.Visible  := True;
  {}
  SpeedButton7.Width  := SpeedButton7.Glyph.Width-4;
  SpeedButton7.Height := SpeedButton7.Glyph.Height-5;
  SpeedButton7.Left := CoolForm1.Left + trunc((CoolForm1.Width - SpeedButton7.Width)/2)+5;
  SpeedButton7.Top  := CoolForm1.Top + 505;
  SpeedButton7.Visible  := True;
  {}

  Memo1.Width   := CoolForm1.Width  - 100;
  Memo1.Height  := CoolForm1.height - 380;
  Memo1.Left    := CoolForm1.Left + trunc((CoolForm1.Width - Memo1.Width)/2){-5};
  Memo1.Top     := CoolForm1.Top + 120;
  Memo1.Visible := False;
  Initialize;

end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  { Exit }
  Wave2.Play;
  CCls := True;
  Application.Terminate;
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  { OnClose }
  CanClose := CCls;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Form1.Position  := poScreenCenter;
end;

procedure TForm1.SpeedButton3Click(Sender: TObject);
begin
  { SAVE }
  Wave2.Play;
  If (Length(RezTip) = 0) Then ShowMessage('  .')
  Else
  Begin
    SaveDialog1.InitialDir := Dir;
    SaveDialog1.Execute;
    If (Length(SaveDialog1.FileName) <> 0) Then
    Begin
      AssignFile(F1,ExtractFilename(SaveDialog1.FileName));
      ReWrite(F1);
      Write(F1,RezTip);
      CloseFile(F1);
      SaveDialog1.FileName := '';
    End;
  End;  
end;

procedure TForm1.SpeedButton2Click(Sender: TObject);
begin
  { Test }
  Wave2.Play;
  {}
  SpeedButton5.Width  := SpeedButton5.Glyph.Width{-3};
  SpeedButton5.Height := SpeedButton5.Glyph.Height{-5};
  {}
  SpeedButton6.Width  := SpeedButton6.Glyph.Width{-3};
  SpeedButton6.Height := SpeedButton6.Glyph.Height{-5};

  SpeedButton5.Left := CoolForm1.Left + trunc((CoolForm1.Width - (SpeedButton5.Width + SpeedButton5.Width+30))/2)+5;
  SpeedButton6.Left := SpeedButton5.Left + SpeedButton5.Width + 30;
  SpeedButton5.Top  := CoolForm1.Top + 500;
  SpeedButton6.Top  := SpeedButton5.Top;
  SpeedButton5.Visible  := True;
  SpeedButton6.Visible  := True;

  Form1.HideMenu;
  Memo1.Visible := True;
  q := qarr[1,1];
  Test(q);
end;

procedure TForm1.SpeedButton4Click(Sender: TObject);
Var
  prg     : PChar;
begin
  { Help }
  Wave2.Play; prg := 'svg_br_web.exe index.htm'; 
{  StrPCopy(prg,'tt.exe');}
  WinExec(prg,1);
end;

procedure TForm1.SpeedButton5Click(Sender: TObject);
begin
  { Yes }
  Wave2.Play;
  If mems Then
  Begin
    Memo1.Visible := False;
    ShowMenu; mems := false; A := 0; B := 0;
    Exit;
  End;

  ResGenerate(True);
end;
procedure TForm1.SpeedButton6Click(Sender: TObject);
begin
  { No }
  Wave2.Play;
  ResGenerate(False);
end;

procedure TForm1.ResGenerate(Y_N : Boolean);
Begin
  {   }
  If (qarr[A,B+1].ok = True) {OR (B+1 <= nqws)} Then
  Begin
    If Y_N Then qarr[A,B].yn := 1 Else qarr[A,B].yn := 0;
    B := B + 1;   NN := NN + 1;
    Test(qarr[A,B]);
  End
  Else
  Begin
    If Y_N Then qarr[A,B].yn := 1 Else qarr[A,B].yn := 0;
    A := A + 1; B := 1;
    NN := 1; Test(qarr[A,B]);
  End;
  If (A > ntips) Then Veryfic;
End;

procedure TForm1.Veryfic;
Var
  tip1,tip2              : integer;
  ii,jj                  : integer;
Begin
  {   }
  YesNo; Memo1.Clear;
  tip1 := 0; tip2 := 0; RezTip := '';
  For ii := 1 To (ntips div 2) Do
  Begin
    For jj := 1 To nqws  Do
    Begin
      tip1 := tip1 + qarr[ii*2-1,jj].yn;
      tip2 := tip2 + qarr[ii*2,jj].yn;
    End;
    Memo1.Lines.Add(qarr[ii*2-1,1].ptip + ' : ' + IntToStr(tip1));
    Memo1.Lines.Add(qarr[ii*2,1].ptip + ' : ' + IntToStr(tip2));
    If (tip1 <= tip2) Then Reztip := Reztip + qarr[ii*2,1].ptip
    Else Reztip := Reztip + qarr[ii*2-1,1].ptip;
    tip1 := 0; tip2 := 0;
  End;
  Memo1.Lines.Add('  : ' + RezTip);
  Memo1.Lines.LoadFromFile(RezTip);
  SpeedButton5.Left := CoolForm1.Left + trunc((CoolForm1.Width - SpeedButton5.Width)/2)+5;
  SpeedButton5.Top  := CoolForm1.Top + 470;
  SpeedButton5.Visible  := True;
  mems := True;
End;

procedure TForm1.SpeedButton7Click(Sender: TObject);
Var
  p       : integer;
begin
  { LOAD }
  Wave2.Play;
  OpenDialog1.InitialDir := Dir;
  OpenDialog1.Execute;
{  Dir := OpenDialog1.GetNamePath;}
  If (Length(OpenDialog1.FileName) <> 0) Then
  Begin
    AssignFile(F1,OpenDialog1.FileName);
    ReSet(F1);
    BlockRead(F1,RezTip,sizeof(RezTip),p);
    CloseFile(F1);
    If FileExists(RezTip)Then
    Begin
      Memo1.Visible := True;
      Memo1.Lines.LoadFromFile(RezTip);
      HideMenu;
      SpeedButton5.Width  := SpeedButton5.Glyph.Width{-3};
      SpeedButton5.Height := SpeedButton5.Glyph.Height{-5};
      SpeedButton5.Left := CoolForm1.Left + trunc((CoolForm1.Width - SpeedButton5.Width)/2)+5;
      SpeedButton5.Top  := CoolForm1.Top + 470;
      SpeedButton5.Visible  := True;
      mems := True;
      OpenDialog1.FileName := '';
    End
    Else ShowMessage('    !');
  End;
end;

end.
